read "C:\WinAPE\NitaGame\NitaGame-1\Entities\Entity.asm"
read "C:\WinAPE\NitaGame\NitaGame-1\Sprytes\Avispa.graf"
read "C:\WinAPE\NitaGame\NitaGame-1\Sprytes\Spry.graf"
read "C:\WinAPE\NitaGame\NitaGame-1\Sprytes\Raqueta.graf"
read "C:\WinAPE\NitaGame\NitaGame-1\Sprytes\Spider.graf"
read "C:\WinAPE\NitaGame\NitaGame-1\Sprytes\Pinchos.graf"
read "C:\WinAPE\NitaGame\NitaGame-1\Sprytes\Huevo.graf"
read "C:\WinAPE\NitaGame\NitaGame-1\Entities\Nita.asm"
read "C:\WinAPE\NitaGame\NitaGame-1\Sprytes\Nita.graf"
read "C:\WinAPE\NitaGame\NitaGame-1\Sprytes\Moneda.graf"
read "C:\WinAPE\NitaGame\NitaGame-1\Sprytes\Botiquin.graf"
read "C:\WinAPE\NitaGame\NitaGame-1\Sprytes\Humo.graf"
read "C:\WinAPE\NitaGame\NitaGame-1\Sprytes\Velas.graf"

llaveCogida: db 1

save_entitie: dw 0

num_huevos: db 12

let entityParams 	= 22	;; Número de parámetros del array de entidades

entityElements: db 0

let s_entity	= 0			;; bit 7: activo, bit 6: cogido
let s_type    	= 1         ;; Tipo de enemigo
let s_X         = 2			;; Coordenada X del enemigo
let s_Y         = 3			;; Coordenada Y del enemigo
let s_base      = 4			;; Coordenada Y base del enemigo
let s_limL      = 5			;; Coordenada X izquierda limite del enemigo
let s_limR      = 6			;; Coordenada X derecha limite del enemigo
let s_orient    = 7			;; Orientación del enemigo izquierda o derecha
let s_status    = 8			;; Estado del enemigo
let s_posXC000  = 9			;; Coordenada X en la pantalla C000
let s_posYC000  = 10		;; Coordenada Y en la pantalla C000
let s_posX8000  = 11		;; Coordenada X en la pantalla 8000
let s_posY8000  = 12		;; Coordenada Y en la pantalla 8000
let s_jump      = 13        ;; Tiempo de salto
let s_jumping   = 14		;; Personaje saltando
let s_mov       = 15        ;; Tipo de movimiento
let s_ancho		= 16		;; Ancho
let s_alto		= 17		;; Alto
let s_takX 		= 18		;; Coordenada X de la entidad cuando está cogida
let s_takY 		= 19		;; Coordenada Y de la entidad cuando está cogida
let s_init_x 	= 20		;; Posicion x inicial
let s_init_y 	= 21		;; Posicion y inicial	

render_entities:
	;;ld ix, entities1
	db #DD,#21
	entidades: db 0,0

	ld c, entityParams
	ld a, (entityElements)
	ld b, a
	loop_rend_entity_1:
		dec ix
		dec c
		jp nz, loop_rend_entity_1
	loop_render_entity:
	ld c, entityParams
	loop_rend_entity_2:
		inc ix
		dec c
		jp nz, loop_rend_entity_2

		push bc

		db #CD
		function_loop: db 0,0
		pop bc
		djnz loop_render_entity
	ret

renderiza_movimiento:
	ld a, (ix + s_mov)
	dec a
	call z, Entity_Horizotal_movement
	ld a, (ix + s_mov)
	dec a
	dec a
	call z, Entity_Vertical_movement
   	call colisiones_enemigo
	ret

render_entity:
	condition isNotRet, ix + s_entity, ACTIVO, null
	condition isNotCall, ix + s_entity, OBJECT_TAKEN, posicionar_no_cogido
	condition isCall, ix + s_entity, OBJECT_TAKEN, posicionar_cogido
	ld a, (ix + s_orient)
	cp ORIENTATION_RIGHT
	jp z, render_entity_R
	jp render_entity_L

render_entity_R:
	condition Equals, ix + s_status, RENDER_STATE1, Entity_paso_R

	ld b, (ix + s_type)
	call select_entity_R_type
	ld a, RENDER_STATE1
	jp render

	Entity_paso_R:
	ld b, (ix + s_type)
	call select_entity_R_type2
	ld a, RENDER_STATE0
	jp render

render_entity_L:
	condition Equals, ix + s_status, RENDER_STATE1, Entity_paso_L

	ld b, (ix + s_type)
	call select_entity_L_type
	ld a, RENDER_STATE1
	jp render

	Entity_paso_L:
	ld b, (ix + s_type)
	call select_entity_L_type2
	ld a, RENDER_STATE0
	jp render

posicionar_no_cogido:
	ld a, (ix + s_Y)
	ld (GR_pos_y), a
	ld a, (ix + s_X)
	ld (GR_pos_x), a
	call posiciona_en_pantalla
	ret

posicionar_cogido:
	ld a, (ix + s_takY)
	ld (GR_pos_y), a
	ld a, (ix + s_takX)
	ld (GR_pos_x), a
	call posiciona_en_pantalla
	ret

render:
    ld (ix + s_status), a
    call fill_graph
    ret

colisiones_enemigo:
    call get_pos_X_Anterior
    ld b, a
    call get_Entity_pos_X_Anterior
    cp b
    jp z, colisiones_Y_Enemigo

    call get_pos_X_Anterior
    inc a
    ld b, a
    call get_Entity_pos_X_Anterior
    cp b
    jp z, colisiones_Y_Enemigo

    call get_pos_X_Anterior
    inc a
    inc a
    ld b, a
    call get_Entity_pos_X_Anterior
    cp b
    jp z, colisiones_Y_Enemigo

    call get_Entity_pos_X_Anterior
    ld b, a
    call get_pos_X_Anterior
    sub b
    jp z, colisiones_Y_Enemigo

    call get_Entity_pos_X_Anterior
    inc a
    ld b, a
    call get_pos_X_Anterior
    sub b
    jp z, colisiones_Y_Enemigo

	condition ZeroRet, ix + s_ancho, 1, null

    call get_Entity_pos_X_Anterior
    inc a
    inc a
    ld b, a
    call get_pos_X_Anterior
    sub b
    jp z, colisiones_Y_Enemigo

	condition ZeroRet, ix + s_ancho, 2, null

    call get_Entity_pos_X_Anterior
    inc a
    inc a
	inc a
    ld b, a
    call get_pos_X_Anterior
    sub b
    jp z, colisiones_Y_Enemigo
    ret
	
colisiones_Y_Enemigo:
	call get_pos_Y_Anterior
    inc a
    ld b, a
    call get_Entity_pos_Y_Anterior
    sub b
    jp z, tipo_Colision

    call get_pos_Y_Anterior
    ld b, a
    call get_Entity_pos_Y_Anterior
    cp b
    jp z, tipo_Colision

	condition ZeroRet, ix + s_alto, 1, null
	condition ZeroRet, Nita_agachado_ind, 1, null  ;; Al agacharse la altura de colision disminuye

	call get_pos_Y_Anterior
    dec a
    ld b, a
    call get_Entity_pos_Y_Anterior
    sub b
    jp z, tipo_Colision
    ret

tipo_Colision:
	condition isNotRet, ix + s_entity, ACTIVO, null
	condition ZeroRet, ix + s_type, OBJ_BASEHUEVO, null
	condition ZeroRet, ix + s_type, OBJ_PUERTAABIERTA, null
	condition Zero, ix + s_type, OBJ_BOTIQUIN, procesa_Botiquin
	condition Zero, ix + s_type, OBJ_HUEVO, procesa_Huevo
	condition Zero, ix + s_type, OBJ_MONEDA, procesaMoneda
	condition Zero, ix + s_type, OBJ_LLAVE, procesa_Llave
	condition NotZero, parpadeo, NITA_PARPADEA, setNita_muere ;; Si esta parpadeando Nita es inmune
	ret

procesa_Botiquin:
	set parpadeo, NITA_PARPADEA		;; Parpadeo e inmunidad temporal
	call setObjeto_Cogido
	call desactiva_entidad
	call suma_vida
	ret

procesa_Huevo:
	call suma_huevo
	call setObjeto_Cogido
	ret

finJuego:
	cleanScreenArea CUADRO_C000, 4, 38, 2, 19, INK1
	cleanScreenArea CUADRO_8000, 4, 38, 2, 19, INK1
	call DB_execute
	renderSpryteSimple 8, 3, GR_FinJuego
	printString 39, 3, txt_theend
	printString 39, 7, txt_fin1
	printString 39, 9, txt_fin2
	printString 39, 11, txt_fin3
	printString 17, 15, txt_next
	call DB_execute
	renderSpryteSimple 8, 3, GR_FinJuego
	printString 39, 3, txt_theend
	printString 39, 7, txt_fin1
	printString 39, 9, txt_fin2
	printString 39, 11, txt_fin3
	printString 17, 15, txt_next
	fin_bucle:
	call detecta_teclas_hardware
	ld a, (teclado)

	cp %00100000
	jp z, wink_Amstrad
	jp fin_bucle

	wink_Amstrad:
	cleanScreenArea CUADRO_C000, 4, 38, 2, 19, INK1
	cleanScreenArea CUADRO_8000, 4, 38, 2, 19, INK1
	call DB_execute
	renderSpryteSimple 34, 3, GR_Velas
	printNumber 10, 6, num_Anys
	printString 15, 6, txt_winkAmstrad1
	printString 12, 8, txt_winkAmstrad2
	printString 24, 10, txt_winkAmstrad3
	printString 17, 15, txt_next
	call DB_execute
	renderSpryteSimple 34, 3, GR_Velas
	printNumber 10, 6, num_Anys
	printString 15, 6, txt_winkAmstrad1
	printString 12, 8, txt_winkAmstrad2
	printString 24, 10, txt_winkAmstrad3
	printString 17, 15, txt_next
	fin_bucle2:
	call detecta_teclas_hardware
	ld a, (teclado)

	cp %00100000
	jp z, thanks
	jp fin_bucle2

	thanks:
	cleanScreenArea CUADRO_C000, 4, 38, 2, 19, INK1
	cleanScreenArea CUADRO_8000, 4, 38, 2, 19, INK1
	call DB_execute
	printString 15, 9, txt_thanks
	printString 20, 15, txt_pressStart
	call DB_execute
	printString 15, 9, txt_thanks
	printString 20, 15, txt_pressStart
	fin_bucle3:
	call detecta_teclas_hardware
	ld a, (teclado)

	cp %00100000
	jp z, menu_principal					;;menu principal
	jp fin_bucle3

procesa_Llave:
	call setObjeto_Cogido
	call desactiva_entidad
	set llaveCogida, 1
	renderSpryte 53, 20, GR_Llave
	call DB_execute
	renderSpryte 53, 20, GR_Llave
	call DB_execute
	ret

procesaMoneda:
	call setObjeto_Cogido
	call desactiva_entidad
	call suma_moneda
	ret

setObjeto_Cogido:
	condition isRet, ix + s_entity, OBJECT_TAKEN, null
	ld a, (ix + s_X)
	ld (Humo_X), a
	ld a, (ix + s_Y)
	ld (Humo_Y), a
	call setHumo_reproduce
	call entidad_cogida
    ret

suma_moneda:
	ld hl, (puntuacion)
	ld de, 5
	add hl, de
	ld (puntuacion), hl
	call convert_decimal
	printNumber 38, 20, valNumericos
	call DB_execute
	printNumber 38, 20, valNumericos
	call DB_execute
	ret

suma_vida:
	call desactiva_entidad
	call entidad_cogida
	call incNitaVidas
	call render_Lives
	call DB_execute
	call render_Lives
	call DB_execute
	ret

suma_huevo:
	condition isRet, ix + s_entity, OBJECT_TAKEN, null
	ld (save_entitie), ix
	ld hl, (puntuacion)
	ld de, 10
	add hl, de
	ld (puntuacion), hl
	call convert_decimal
	printNumber 38, 20, valNumericos
	call DB_execute
	printNumber 38, 20, valNumericos
	call DB_execute
	ld ix, (save_entitie)
	decreases num_huevos
	cp 0
	jp z, finJuego
	ret

initialize_objects:
	set activeScreen, END_SCREEN
	init_loop:
	useScreen
	ld de, setInitialValues
	ld (function_loop), de
	call render_entities
	decreases activeScreen
	jp nz, init_loop
	set activeScreen, START_SCREEN
    ret

setInitialValues:
	ld (ix + s_entity), ACTIVO
	ld a, (ix + s_init_x)
	ld (ix + s_X), a
	ld a, (ix + s_init_y)
	ld (ix + s_Y), a
	ret

entidad_cogida:
	condition isRet, ix + s_entity, OBJECT_TAKEN, null
	get ix + s_entity
	add OBJECT_TAKEN
	ld (ix + s_entity), a
	ret

desactiva_entidad:
	condition isNotRet, ix + s_entity, ACTIVO, null
	get ix + s_entity
	sub ACTIVO
	ld (ix + s_entity), a
	ret
	

