Entity_Horizotal_movement:
	call update_Entity_pos_X_Anterior
	call update_Entity_pos_Y_Anterior
	
	condition Equals, ix + s_type, ENEMY_PINCHO, sin_salto
	condition Equals, ix + s_type, OBJ_HUEVO, sin_salto

	condition Zero, ix + s_jump, 1, Entity_salto_tiempo

	sin_salto:
	ld a, (ix + s_orient)
	cp ORIENTATION_RIGHT
	jp nc, Entity_camina_R
	jp Entity_camina_L

Entity_Vertical_movement:
	call update_Entity_pos_X_Anterior
	call update_Entity_pos_Y_Anterior

	ld a, (ix + s_orient)
	cp ORIENTATION_UP
	jp nc, Entity_up
	jp Entity_down

Entity_salto_tiempo:
	ld a, (ix + s_orient)
	cp ORIENTATION_RIGHT
	jp nc, Entity_salta_R
	jp Entity_salta_L

Entity_camina_R:
	call decEntity_tiempo_salto

	call setEntityOrientacionR

	call render_entity

	call inc_Entity_pos_Y							;; Avanza posición
	ld a, (ix + s_X)
	ld b, a
	ld a, (ix + s_limR)
	cp b
	jp z, setEntityOrientacionL
	call inc_Entity_pos_X							;; Avanza posición
	
	ret

Entity_camina_L:
	call decEntity_tiempo_salto
	
	call setEntityOrientacionL

	call render_entity

	call inc_Entity_pos_Y							;; Avanza posición
	ld a, (ix + s_X)
	ld b, a
	ld a, (ix + s_limL)
	cp b
	jp z, setEntityOrientacionR
	call dec_Entity_pos_X							;; Retrocede posición
	
	ret

Entity_salta_R:
	call decEntity_saltando

	call setEntityOrientacionR

	call render_entity
	
	ld a, (ix + s_Y)
	cp LIMIT_TOP_SCREEN
	call nz, dec_Entity_pos_Y
	ld a, (ix + s_X)
	cp LIMIT_END_SCREEN
	jp z, setEntityOrientacionL
	call inc_Entity_pos_X							;; Avanza posición
	ret

Entity_salta_L:
	call decEntity_saltando

	call setEntityOrientacionL

	call render_entity

	ld a, (ix + s_Y)
	cp LIMIT_TOP_SCREEN
	call nz, dec_Entity_pos_Y
	ld a, (ix + s_X)
	cp LIMIT_START_SCREEN
	jp z, setEntityOrientacionR
    call dec_Entity_pos_X

	ret

Entity_up:
	call render_entity
	jp descuenta
	continua_render:
	ld a, (ix + s_Y)
	cp (ix + s_limL)
	jp z, setEntityOrientacionDown
	call dec_Entity_pos_Y							;; Avanza posición
	ret

retraso_spider: db 4

descuenta:
	decreases retraso_spider
	condition Zero, retraso_spider, 0, reset_spider
	ret

reset_spider:
	set retraso_spider, 6
	jp continua_render

Entity_down:
	call render_entity

	ld a, (ix + s_Y)
	cp (ix + s_limR)
	jp z, setEntityOrientacionUp

	ld a, (ix + s_Y)		;;
	inc a				;; Incrementamos la posicion Y
	ld (ix + s_Y), a		;;
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Funcionas de movimiento - Antes fichero .ent
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

setEntityOrientacionR:
	ld a, ORIENTATION_RIGHT
	ld (ix + s_orient), a
	ret

setEntityOrientacionL:
	ld a, ORIENTATION_LEFT
	ld (ix + s_orient), a
	ret

setEntityOrientacionUp:
	ld a, ORIENTATION_UP
	ld (ix + s_orient), a
	ret

setEntityOrientacionDown:
	ld a, ORIENTATION_DOWN
	ld (ix + s_orient), a
	ret

inc_Entity_pos_X:
	ld a, (ix + s_X)
	ld b, a
	ld a, (ix + s_limR)
	cp b
	ret z
	ld a, (ix + s_X)
	inc a
	ld (ix + s_X), a
	ret

dec_Entity_pos_X:
	ld a, (ix + s_X)
	ld b, a
	ld a, (ix + s_limL)
	cp b
	ret z
	ld a, (ix + s_X)
	dec a
	ld (ix + s_X), a
	ret

inc_Entity_pos_Y:
	ld a, (ix + s_Y)
	ld b, a
	ld a, (ix + s_base)
	cp b
	ret z
	ld a, (ix + s_Y)
	inc a
	ld (ix + s_Y), a
	ret

dec_Entity_pos_Y:
	ld a, (ix + s_Y)
	cp LIMIT_TOP_SCREEN
	ret z
	ld a, (ix + s_Y)
	dec a
	ld (ix + s_Y), a
	ret

decEntity_tiempo_salto:
	ld a, (ix + s_jump)
	cp 1
	ret z

	ld a, 3				;; Reiniciamos el salto
	ld (ix + s_jumping), a		;;

	ld a, (ix + s_jump)
	dec a
	ld (ix + s_jump), a
	ret

setEntity_tiempo_salto_Reinicia:
	call getNumeroAleatorio
	ld (ix + s_jump), a
	ret

decEntity_saltando:
	ld a, (ix + s_jumping)
	cp 1
	jp z, setEntity_tiempo_salto_Reinicia

	ld a, (ix + s_jumping)
	dec a
	ld (ix + s_jumping), a
	ret

update_Entity_pos_X_Anterior:
	condition Equals, DB_screen_selected, DB_BUFFER_C000, update_Entity_pos_X_C000
	jp update_Entity_pos_X_8000

update_Entity_pos_Y_Anterior:
	condition Equals, DB_screen_selected, DB_BUFFER_C000, update_Entity_pos_Y_C000
	jp update_Entity_pos_Y_8000

update_Entity_pos_X_C000:
	ld a, (ix + s_X)
	ld (ix + s_posXC000), a
	ret

update_Entity_pos_Y_C000:
	ld a, (ix + s_Y)
	ld (ix + s_posYC000), a
	ret

update_Entity_pos_X_8000:
	ld a, (ix + s_X)
	ld (ix + s_posX8000), a
	ret

update_Entity_pos_Y_8000:
	ld a, (ix + s_Y)
	ld (ix + s_posY8000), a
	ret

get_Entity_pos_X_Anterior:
	condition Equals, DB_screen_selected, DB_BUFFER_C000, return_Entity_pos_X_C000
	jp return_Entity_pos_X_8000

get_Entity_pos_Y_Anterior:
	condition Equals, DB_screen_selected, DB_BUFFER_C000, return_Entity_pos_Y_C000
	jp return_Entity_pos_Y_8000

return_Entity_pos_X_C000:
	ld a, (ix + s_posXC000)
	ret

return_Entity_pos_X_8000:
	ld a, (ix + s_posX8000)
	ret

return_Entity_pos_Y_C000:
	ld a, (ix + s_posYC000)
	ret

return_Entity_pos_Y_8000:
	ld a, (ix + s_posY8000)
	ret

select_entity_R_type:
	dec b
	jp z, entity_R_type1
	dec b
	jp z, entity_R_type2
	dec b
	jp z, entity_R_type3
	dec b
	jp z, entity_R_type4
	dec b
	jp z, entity_R_type5
	dec b
	jp z, obj_R_type5
	dec b
	jp z, obj_R_typeHuevo1
	dec b
	jp z, obj_R_typeBotiquin1
	dec b
	jp z, obj_R_typeBase1
	dec b
	jp z, obj_R_typeLlave
	dec b
	jp z, obj_R_PuertaAbierta
	dec b
	jp z, obj_R_typeAgua1
	ret

select_entity_R_type2:
	dec b
	jp z, entity_R_type12
	dec b
	jp z, entity_R_type22
	dec b
	jp z, entity_R_type32
	dec b
	jp z, entity_R_type42
	dec b
	jp z, entity_R_type5
	dec b
	jp z, obj_R_type52
	dec b
	jp z, obj_R_typeHuevo12
	dec b
	jp z, obj_R_typeBotiquin1
	dec b
	jp z, obj_R_typeBase1
	dec b
	jp z, obj_R_typeLlave
	dec b
	jp z, obj_R_PuertaAbierta
	dec b
	jp z, obj_R_typeAgua1
	ret

select_entity_L_type:
	dec b
	jp z, entity_L_type1
	dec b
	jp z, entity_L_type2
	dec b
	jp z, entity_L_type3
	dec b
	jp z, entity_L_type4
	dec b
	jp z, entity_R_type5
	dec b
	jp z, obj_L_type5
	dec b
	jp z, obj_R_typeHuevo1
	dec b
	jp z, obj_R_typeBotiquin2
	dec b
	jp z, obj_R_typeBase2
	dec b
	jp z, obj_R_typeLlave
	dec b
	jp z, obj_R_PuertaAbierta
	dec b
	jp z, obj_R_typeAgua2
	ret

select_entity_L_type2:
	dec b
	jp z, entity_L_type12
	dec b
	jp z, entity_L_type22
	dec b
	jp z, entity_L_type32
	dec b
	jp z, entity_L_type42
	dec b
	jp z, entity_R_type5
	dec b
	jp z, obj_L_type52
	dec b
	jp z, obj_R_typeHuevo12
	dec b
	jp z, obj_R_typeBotiquin1
	dec b
	jp z, obj_R_typeBase2
	dec b
	jp z, obj_R_typeLlave
	dec b
	jp z, obj_R_PuertaAbierta
	dec b
	jp z, obj_R_typeAgua2
	ret

entity_R_type1:
	ld de, GR_spry_camina_R
	ret

entity_R_type12:
	ld de, GR_spry_camina_R2
	ret

entity_L_type1:
	ld de, GR_spry_camina_L
	ret

entity_L_type12:
	ld de, GR_spry_camina_L2
	ret

entity_R_type2:
	ld de, GR_raqueta_camina_R
	ret

entity_R_type22:
	ld de, GR_raqueta_camina_R2
	ret

entity_L_type2:
	ld de, GR_raqueta_camina_L
	ret

entity_L_type22:
	ld de, GR_raqueta_camina_L2
	ret

entity_R_type3:
	ld de, GR_avispa_camina_R
	ret

entity_R_type32:
	ld de, GR_avispa_camina_R2
	ret

entity_L_type3:
	ld de, GR_avispa_camina_L
	ret

entity_L_type32:
	ld de, GR_avispa_camina_L2
	ret

entity_R_type4:
	ld de, GR_Spider_1
	ret

entity_R_type5:
	ld de, GR_Pinchos
	ret

entity_R_type42:
	ld de, GR_Spider_2
	ret

entity_L_type4:
	ld de, GR_Spider_1
	ret

entity_L_type42:
	ld de, GR_Spider_2
	ret

obj_L_type5:
	ld de, GR_Moneda1
	ret

obj_L_type52:
	ld de, GR_Moneda12
	ret

obj_R_type5:
	ld de, GR_Moneda2
	ret

obj_R_type52:
	ld de, GR_Moneda22
	ret

obj_R_typeHuevo1:
	ld de, GR_Huevo
	ret

obj_R_typeHuevo12:
	ld de, GR_Huevo2
	ret

obj_R_typeBotiquin1:
	ld de, GR_Botiquin
	ret

obj_R_typeBotiquin2:
	ld de, GR_Botiquin2
	ret

obj_R_typeBase1:
	ld de, GR_baseHuevo
	ret

obj_R_typeBase2:
	ld de, GR_baseHuevo2
	ret

obj_R_typeLlave:
	ld de, GR_Llave
	ret

obj_R_PuertaAbierta:
	ld de, GR_PuertaAbierta
	ret

obj_R_typeAgua1:
	ld de, GR_Agua1
	ret

obj_R_typeAgua2:
	ld de, GR_Agua2
	ret