read "C:\WinAPE\NitaGame\NitaGame-1\Libs\Lib_Teclado.asm"
read "C:\WinAPE\NitaGame\NitaGame-1\Entities\Nita.ent"

parpadeo: db 0							;; Activa el parpadeo de Nita
parpadeando: db NITA_TIEMPO_PARPADEO	;; Tiempo parpadenado
marcador_parpadeo: db 1					;; Marcador inerno para la función de parpadeo

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MOVER HEROE                                              ;;
;; Mueve la heroe                                           ;;
;; ENTRADA posicion_heroe 				                    ;;
;; MODIFICA hl						                        ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mover_heroe:
	set Nita_agachado_ind, 2
	call update_pos_X_Anterior
	call update_pos_Y_Anterior
	
	call detecta_teclas_hardware
	ld a, (teclado)
	
	cp %00000101
	jp z, Nita_salta_R					;;arriba_derecha
	cp %00000110
	jp z, Nita_salta_L  				;;arriba_izquierda
	cp %00001001
	jp z, Nita_agachado_R				;;abajo_derecha
	cp %00001010
	jp z, Nita_agachado_L 				;;abajo_izquierda
	cp %00000100
	jp z, Nita_salta_U					;;tecla_arriba
	cp %00001000
	jp z, Nita_agachado 				;;tecla_abajo
	cp %00000010
	jp z, Nita_camina_L					;;izquierda
	cp %00000001
	jp z, Nita_camina_R					;;derecha
	cp %00010001
	jp z, menu_principal				;;finalizar

	cp %00010000
	jp z, menu_principal				;;reset
	
	jp Nita_parado
	ret

Nita_camina_R:
	set Nita_orientacion, ORIENTATION_RIGHT
	ld hl, GR_Nita_camina_R
	ld (rend_Nita1), hl
	ld hl, GR_Nita_camina_R2
	ld (rend_Nita2), hl
	ld hl, inc_pos_Y
	ld (mov_desp_vertical), hl
	ld a, LIMIT_END_SCREEN - 1
	ld (mov_limit_screen), a
	ld hl, inc_pos_X
	ld (mov_desp_horizontal), hl
	jp Nita_mueve

Nita_camina_L:
	set Nita_orientacion, ORIENTATION_LEFT
	ld hl, GR_Nita_camina_L
	ld (rend_Nita1), hl
	ld hl, GR_Nita_camina_L2
	ld (rend_Nita2), hl
	ld hl, inc_pos_Y
	ld (mov_desp_vertical), hl
	ld a, LIMIT_START_SCREEN + 1
	ld (mov_limit_screen), a
	ld hl, dec_pos_X
	ld (mov_desp_horizontal), hl
	jp Nita_mueve

Nita_salta_R:
	set Nita_orientacion, ORIENTATION_RIGHT
	ld hl, GR_Nita_Salto_R
	ld (rend_Nita1), hl
	ld hl, GR_Nita_Salto_R2
	ld (rend_Nita2), hl
	ld hl, dec_pos_Y
	ld (mov_desp_vertical), hl
	ld a, LIMIT_END_SCREEN - 1
	ld (mov_limit_screen), a
	ld hl, inc_pos_X
	ld (mov_desp_horizontal), hl
	jp Nita_mueve

Nita_salta_L:
	set Nita_orientacion, ORIENTATION_LEFT
	ld hl, GR_Nita_Salto_L
	ld (rend_Nita1), hl
	ld hl, GR_Nita_Salto_L2
	ld (rend_Nita2), hl
	ld hl, dec_pos_Y
	ld (mov_desp_vertical), hl
	ld a, LIMIT_START_SCREEN + 1
	ld (mov_limit_screen), a
	ld hl, dec_pos_X
	ld (mov_desp_horizontal), hl
	jp Nita_mueve

Nita_mueve:
	call renderiza_Nita

	db #CD
	mov_desp_vertical: db 0,0
	get Nita_pos_X
	db #FE
	mov_limit_screen: db 0
	db #CD
	mov_desp_horizontal: db 0,0
	ret

renderiza_Nita:
	condition Equals, Nita_estado, RENDER_STATE1, anim_Nita
	
	call locate_nita
	db #11
	rend_Nita1: db 0,0
	call fill_graph_Nita
	set Nita_estado, RENDER_STATE1
	jp Dibuja_fin

	anim_Nita:
	call locate_nita
	db #11
	rend_Nita2: db 0,0
	call fill_graph_Nita
	set Nita_estado, RENDER_STATE0
	Dibuja_fin:
	ret
	
locate_nita:
	ld a, (Nita_pos_Y)
	ld (GR_pos_y), a
	ld a, (Nita_pos_X)
	ld (GR_pos_x), a
	call posiciona_en_pantalla
	ret

Nita_parado:
	condition Zero, Nita_estado_parado, TIME_RENDER_STATE0, Nita_parado2

	call locate_nita
	ld de, GR_Nita_parado
	call fill_graph_Nita

	decreases Nita_estado_parado
	set Nita_estado_parado2, TIME_RENDER_STATE2
	jp fin_quieto

    Nita_parado2:
	call locate_nita
	ld de, GR_Nita_parado2
	call fill_graph_Nita
	decreases Nita_estado_parado2
	jp nz, fin_quieto
	set Nita_estado_parado, TIME_RENDER_STATE40

	fin_quieto:
	call comprueba_superficie					;;Get Nita_pos_X valor mínimo
	call nz, inc_pos_Y					;;Avanza posición
	ret

Nita_agachado:
	condition Equals, Nita_Orientacion, ORIENTATION_RIGHT, Nita_agachado_R
	jp Nita_agachado_L
	ret

Nita_agachado_R:
	set Nita_agachado_ind, 1
	set Nita_orientacion, ORIENTATION_RIGHT
	condition Zero, Nita_estado_parado, TIME_RENDER_STATE0, Nita_agachado_R2

	call locate_nita
	ld de, GR_Nita_agachado_R
	call fill_graph_Nita
	decreases Nita_estado_parado
	set Nita_estado_parado2, TIME_RENDER_STATE2
	jp fin_agachado_R

    Nita_agachado_R2:
	call locate_nita
	ld de, GR_Nita_agachado_R2
	call fill_graph_Nita
	decreases Nita_estado_parado2
	jp nz, fin_agachado_R
	set Nita_estado_parado, TIME_RENDER_STATE40

	fin_agachado_R:
	call comprueba_superficie					;;Get Nita_pos_X valor mínimo
	call nz, inc_pos_Y					;;Avanza posición
	ret

Nita_agachado_L:
	set Nita_agachado_ind, 1
	set Nita_orientacion, ORIENTATION_LEFT
	condition Zero, Nita_estado_parado, TIME_RENDER_STATE0, Nita_agachado_L2

	call locate_nita
	ld de, GR_Nita_agachado_L
	call fill_graph_Nita
	decreases Nita_estado_parado
	set Nita_estado_parado2, TIME_RENDER_STATE2
	jp fin_agachado_L

    Nita_agachado_L2:
	call locate_nita
	ld de, GR_Nita_agachado_L2
	call fill_graph_Nita
	decreases Nita_estado_parado2
	jp nz, fin_agachado_L
	set Nita_estado_parado, TIME_RENDER_STATE40

	fin_agachado_L:
	call comprueba_superficie			;;Get Nita_pos_X valor mínimo
	call nz, inc_pos_Y					;;Avanza posición
	ret

Nita_salta_U:
	condition Equals, Nita_Orientacion, ORIENTATION_RIGHT, Nita_salta_UR
	jp Nita_salta_UL
	ret

Nita_salta_UR:
	condition Equals, Nita_estado, RENDER_STATE1, Nita_salto4

	call locate_nita
	ld de, GR_Nita_Salto_R
	call fill_graph_Nita
	set Nita_estado, RENDER_STATE1
	jp Salta4_fin

	Nita_salto4:
	call locate_nita
	ld de, GR_Nita_Salto_R2
	call fill_graph_Nita
	set Nita_estado, RENDER_STATE0

	Salta4_fin:
	call dec_pos_Y
	ret

Nita_salta_UL:
	condition Equals, Nita_estado, RENDER_STATE1, Nita_salto3

	call locate_nita
	ld de, GR_Nita_Salto_L
	call fill_graph_Nita
	set Nita_estado, RENDER_STATE1
	jp Nita_salta_UL_End

	Nita_salto3:
	call locate_nita
	ld de, GR_Nita_Salto_L2
	call fill_graph_Nita
	set Nita_estado, RENDER_STATE0

	Nita_salta_UL_End:
	call dec_pos_Y
	ret

temblado: db 0

Nita_pierde:
	ld a, (temblado)
	cp 0
	call z, temblor
	set temblado, 1
	renderSubject Nita_pos_X, Nita_pos_Y, GR_Nita_pierde
	call inc_pos_Y
	printString 27, 9, txt_NoConseguido
	ret

resetea:
	set Nita_vidas, ALL_LIVES
	jp reinicia

puntero_vidas: db 0

render_Lives:
	ld a, (Nita_vidas)
	inc a
	ld (puntero_vidas), a
	dec a
	ret z
	ld (puntero_vidas), a
	renderSpryteSimple 37, 21, vida
	ld a, (puntero_vidas)
	dec a
	ret z
	ld (puntero_vidas), a
	renderSpryteSimple 41, 21, vida
	ld a, (puntero_vidas)
	dec a
	ret z
	ld (puntero_vidas), a
	renderSpryteSimple 45, 21, vida
	ret

decrease_Lives:
	condition ZeroCall, Nita_vidas, 0, clean_AllLives
	condition ZeroCall, Nita_vidas, 1, clean_2Lives
	condition ZeroCall, Nita_vidas, 2, clean_1Lives
	ret

clean_2Lives:
	cleanScreenArea CUADRO_8000, 24, 28, 22, 24, INK1
	cleanScreenArea CUADRO_C000, 24, 28, 22, 24, INK1
	ret

clean_1Lives:
	cleanScreenArea CUADRO_8000, 26, 28, 22, 24, INK1
	cleanScreenArea CUADRO_C000, 26, 28, 22, 24, INK1
	ret
clean_AllLives:
	cleanScreenArea CUADRO_8000, 22, 28, 22, 24, INK1
	cleanScreenArea CUADRO_C000, 22, 28, 22, 24, INK1
	ret

funcion_parpadeo:
	ld a, (parpadeando)
	dec a
	jp z, desactiva_parpadeo
	condition Zero, marcador_parpadeo, 0, continua_parpadeo
	ld a, 0
	ld (marcador_parpadeo), a
	decreases parpadeando
	ret

desactiva_parpadeo:
	ld a, NITA_NO_PARPADEA
	ld (parpadeo), a
	ld a, NITA_TIEMPO_PARPADEO
	ld (parpadeando), a
	ret

fill_graph_Nita:
	condition Zero, parpadeo, NITA_PARPADEA, funcion_parpadeo
	continua_parpadeo:
	ld a, 1
	ld (marcador_parpadeo), a
	call fill_graph
	ret