;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Manager de CRTC	 																					    ;;
;;																											;;
;; CPCWiki: https://www.cpcwiki.eu/index.php/CRTC														    ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; Registros
H_CHARACTERS    EQU 01
H_ADJUST        EQU 02
V_ADJUST        EQU 05
V_LINES         EQU 06
V_SYNC          EQU 07

;;Control del CRTC
macro CRTC_control register, value
    ld bc, &BC00 + register
	out (c), c
	ld bc, &BD00 + value
	out (c), c
endm

CRTC_V_auto:
	ld bc, &BC00 + V_LINES
	out (c), c
	ld hl, &BD00
	add hl, de
	ld b, h
	ld c, l
	out (c), c
	ret

CRTC_H_auto:
	ld bc, &BC00 + H_ADJUST
	out (c), c
	ld hl, &BD00
	add hl, de
	ld b, h
	ld c, l
	out (c), c
	ret

;;Ajuste de la altura de la pantalla
macro set_Screen_Height value
    CRTC_control V_LINES, value
endm

;;Ajuste del ancho de la pantalla
macro set_Screen_Width value
    CRTC_control H_CHARACTERS, value
endm

;;Ajuste vertical de la pantalla
macro set_Screen_Vertical value
    CRTC_control V_ADJUST, value
endm

;;Ajuste horizontal de la pantalla
macro set_Screen_Horizontal value
    CRTC_control H_ADJUST, value
endm

;;Ajuste VSync - Default 30
macro set_Screen_VSync value
    CRTC_control V_SYNC, value
endm