GR_posicion: dw 0
GR_ancho: db 0
GR_alto: db 0
GR_pos_x: db 0
GR_pos_y: db 0
GR_pos_mem: dw 0
clean_from_x: db 0
clean_from_y: db 0
clean_to_x: db 0
clean_to_y: db 0
clean_x: db 0
clean_y: db 0
color_clean: db 0

clean_tile: db 0

fill_graph:
	ld (GR_posicion), hl		;;Cargaremos la direccion en la variable posicion
	ld a, (de)					;;
	ld (GR_ancho), a			;;Cargaremos el primer valor en la variable ancho
	inc de
	ld a, (de)					;;
	ld (GR_alto), a				;;Cargaremos el segundo valor en la variable alto

	rel_params:
	ld a, (GR_ancho)			;;
	ld b, a						;;Cargamos el valor de ancho en el registro B
	ld c, 8						;;Cargamos 8 en C para recorrer el caracter

	rep_fill:
	inc de
	ld a, (de)
	and (hl)
	ld (hl), a
	inc de
	ld a, (de)
	or a, (hl)

	ld (hl), a					;;
	inc hl						;;Cargamos en la posicion de memoria de HL el valor de DE
	dec b						;;Decrementamos en una unidad el ancho
	jr nz, rep_fill				;;Si no hemos llegado al final del ancho repetimos la misma accion

	call inc_line				;;Incrementamos una linea de pixeles para pintar justo debajo
	ld a, (GR_ancho)			;;
	ld b, a						;;Volvemos a cargar en B el valor de ancho
	dec c						;;Decrementamos c para bajar una linea en el caracter
	jr nz, rep_fill				;;Si no hemos llegado a 0 es que no hemos completado el caracter y volvemos a repetir la misma accion

	call inc_char				;;Incrementamos una linea de caracteres porque hemos llegado al final del primer caracter
	ld a, (GR_alto)				;;
	dec a						;;
	ld (GR_alto), a				;;Decrementamos en una unidad el alto y lo almacenamos
	jr nz, rel_params			;;Si no hemos llegado a 0 el alto volvemos a repetir la misma accion

	ret

fill_graph_simple:
	ld (GR_posicion), hl		;;Cargaremos la direccion en la variable posicion
	ld a, (de)					;;
	ld (GR_ancho), a			;;Cargaremos el primer valor en la variable ancho
	inc de
	ld a, (de)					;;
	ld (GR_alto), a				;;Cargaremos el segundo valor en la variable alto

	rel_params_sp:
	ld a, (GR_ancho)			;;
	ld b, a						;;Cargamos el valor de ancho en el registro B
	ld c, 8						;;Cargamos 8 en C para recorrer el caracter

	rep_fill_sp:
	inc de
	ld a, (de)

	ld (hl), a					;;
	inc hl						;;Cargamos en la posicion de memoria de HL el valor de DE
	dec b						;;Decrementamos en una unidad el ancho
	jr nz, rep_fill_sp			;;Si no hemos llegado al final del ancho repetimos la misma accion

	call inc_line				;;Incrementamos una linea de pixeles para pintar justo debajo
	ld a, (GR_ancho)			;;
	ld b, a						;;Volvemos a cargar en B el valor de ancho
	dec c						;;Decrementamos c para bajar una linea en el caracter
	jr nz, rep_fill_sp			;;Si no hemos llegado a 0 es que no hemos completado el caracter y volvemos a repetir la misma accion

	call inc_char				;;Incrementamos una linea de caracteres porque hemos llegado al final del primer caracter
	ld a, (GR_alto)				;;
	dec a						;;
	ld (GR_alto), a				;;Decrementamos en una unidad el alto y lo almacenamos
	jr nz, rel_params_sp		;;Si no hemos llegado a 0 el alto volvemos a repetir la misma accion

	ret

inc_line:
	ld a, (GR_ancho)
	dec_col:
	dec hl
	dec a
	jp nz, dec_col
	push de
	ld de, #800
	adc hl, de
	pop de
	ret

inc_char:
	ld hl, (GR_posicion)
	push de
	call GR_valor_variable
	adc hl, de
	pop de
	ld (GR_posicion), hl
	ret

GR_valor_variable:
	ld a, (DB_screen_selected)
	cp DB_BUFFER_8000
	jr nc, GR_Valor_8000
	jr GR_Valor_C000

GR_Valor_8000:
	ld de, #50
	ret	

GR_Valor_C000:
	ld de, #4F
	ret

posiciona_en_pantalla:
	call GR_determina_patalla

	ld a, (GR_pos_y)
	dec a
	jr z, sigue_en_x
	
	bucle_pos_y:
		ld de, #50
		add hl, de
		dec a
		jr nz, bucle_pos_y
	
	sigue_en_x:

	ld a, (GR_pos_x)
	dec a
	jr z, carga_pos_mem

	bucle_pos_x:
		inc hl
		dec a
		jr nz, bucle_pos_x
	
	carga_pos_mem:

	ld (GR_pos_mem), hl

	ret

GR_determina_patalla:
	ld a, (DB_screen_selected)
	ld hl, PANTALLA_C000
	cp DB_BUFFER_C000
	ret nc
	ld hl, PANTALLA_8000
	ret

screen_graph:
	ld a, 8
	
	repite_screen_graph:
	ld bc, 2
	ldir
	inc e					;;
	dec e					;; Agregado para los casos de desbordamiento que hace que de dibujen mal en las posiciones
	call z, decAlto			;; Ejemplo C0FF al incrementarse da C100 y debería ser C000

	dec a
	push af

	ld a, d
	add a, #8
	dec de
	dec de
	ld d, a

	pop af
	jr nz, repite_screen_graph

	fin_screen_graph:
	ret

decAlto:
	dec d
	ret

fill_graphic_simple:
	ld (GR_pos_y), a
	ld a, b
	ld (GR_pos_x), a
	push de
	call posiciona_en_pantalla
	pop de
	call fill_graph_simple
	ret

area_clean:
	set clean_x, 0
	set clean_y, 0
	ld hl, (punteroCuadro)
	ld (puntero_memoria), hl
	ld a, 25
	ciclo_clean:
	ld (linea_tiles), a
	increases clean_y
	call ciclo_linea
	get linea_tiles
	dec a
	jr nz, ciclo_clean
	ld (punteroCuadro), hl
	ret

ciclo_linea:
	set clean_x, 0
	ld a, 40
	ciclo_linea2:
	ld (tile_linea), a
	increases clean_x
	call current_line
	condition ZeroCall, clean_tile, 1, clean
	nextTilePosition				;; Siguiente posición en memoria de video
	get tile_linea					;;
	dec a							;;
	jr nz, ciclo_linea2					;;
	ret

clean:
	ld a, (color_clean)
	condition Zero, color_clean, 3, clean_white
	condition Zero, color_clean, 2, clean_green
	condition Zero, color_clean, 1, clean_black

clean_green:
	ld hl, vacio_verde
	ld de, (puntero_memoria)
	call screen_graph
	ret

clean_black:
	ld hl, vacio
	ld de, (puntero_memoria)
	call screen_graph
	ret

clean_white:
	ld hl, vacio_blanco
	ld de, (puntero_memoria)
	call screen_graph
	ret

cleaneable:
	set clean_tile, 1
	ret

not_cleaneable:
	set clean_tile, 0
	ret

current_line:
	condition Major, clean_y, clean_from_y, limit_line
	call not_cleaneable
	ret

limit_line:
	condition MinorOrEquals, clean_y, clean_to_y, current_tile
	call not_cleaneable
	ret

current_tile:
	condition Major, clean_x, clean_from_x, limit_tile
	call not_cleaneable
	ret

limit_tile:
	condition MinorOrEquals, clean_x, clean_to_x, cleaneable
	call not_cleaneable
	ret