teclado:            db 0

tecla_izquierda:    dw &0002
tecla_O:            dw &0404
tecla_derecha:      dw &0101
tecla_P:            dw &0308
tecla_arriba:       dw &0001
tecla_Q:            dw &0808
tecla_abajo:        dw &0004
tecla_A:            dw &0820
tecla_S:            dw &0710
tecla_ESC:          dw &0804

; 0001 Flecha arriba
; 0002 Flecha izquierda
; 0004 Flecha abajo
; 0008 DESCONOCIDO
; 0010 DESCONOCIDO
; 0020 DESCONOCIDO
; 0040 DESCONOCIDO
; 0080 DESCONOCIDO

; 0101 Flecha derecha
; 0102 CTRL izq
; 0104 DESCONOCIDO
; 0108
; 0110
; 0120
; 0140
; 0180

; 0201
; 0202
; 0204 ENTER
; 0208
; 0210
; 0220
; 0240
; 0280

; 0301
; 0302
; 0304
; 0308 P
; 0310
; 0320
; 0340
; 0380

; 0401
; 0402
; 0404 O
; 0408
; 0410
; 0420
; 0440
; 0480

; 0501
; 0502
; 0504
; 0508
; 0510
; 0520 J
; 0540 N
; 0580 SPACE

; 0601 6
; 0602 5
; 0604 R
; 0608 T
; 0610 G
; 0620 F
; 0640 B
; 0680 V

; 0701 4
; 0702 3
; 0704 E
; 0708 W
; 0710 S
; 0720 D
; 0740 C
; 0780 X

; 0801 1
; 0802 2
; 0804 ESC
; 0808 Q
; 0810 TAB
; 0820 A
; 0840 BLOQ Mayusculas
; 0880 Z                            

detecta_teclas_hardware:
    di
    call comprobacion_teclas_pulsadas
    ei
ret

comprobacion_teclas_pulsadas
    xor a
    ld (teclado), a                 ;;Reinicia a 0 la vble teclado

    ld hl, tecla_S + 1              ;;
    ld de, tecla_s_pulsada          ;; Deteccion tecla S
    ld (funcion_tecla), de          ;;
    call deteccion_tecla            ;;

    ld hl, tecla_izquierda + 1      ;;
    ld de, tecla_izquierda_pulsada  ;; Deteccion tecla cursor izquierda
    ld (funcion_tecla), de          ;;
    call deteccion_tecla            ;;

    ld hl, tecla_P + 1              ;;
    ld de, tecla_izquierda_pulsada  ;; Deteccion tecla P
    ld (funcion_tecla), de          ;;
    call deteccion_tecla            ;;

    ld hl, tecla_derecha + 1        ;;
    ld de, tecla_derecha_pulsada    ;; Deteccion tecla cursor derecha
    ld (funcion_tecla), de          ;;
    call deteccion_tecla            ;;

    ld hl, tecla_O + 1              ;;
    ld de, tecla_derecha_pulsada    ;; Deteccion tecla O
    ld (funcion_tecla), de          ;;
    call deteccion_tecla            ;;

    ld hl, tecla_arriba + 1         ;;
    ld de, tecla_arriba_pulsada     ;; Deteccion tecla cursor arriba
    ld (funcion_tecla), de          ;;
    call deteccion_tecla            ;;

    ld hl, tecla_Q + 1              ;;
    ld de, tecla_arriba_pulsada     ;; Deteccion tecla Q
    ld (funcion_tecla), de          ;;
    call deteccion_tecla            ;;

    ld hl, tecla_abajo + 1          ;;
    ld de, tecla_abajo_pulsada      ;; Deteccion tecla cursor abajo
    ld (funcion_tecla), de          ;;
    call deteccion_tecla            ;;

    ld hl, tecla_A + 1              ;;
    ld de, tecla_abajo_pulsada      ;; Deteccion tecla A
    ld (funcion_tecla), de          ;;
    call deteccion_tecla            ;;

    ld hl, tecla_ESC + 1            ;;
    ld de, esc_pulsado              ;; Deteccion tecla ESC
    ld (funcion_tecla), de          ;;
    call deteccion_tecla            ;;

    ret

deteccion_tecla:
    ld a,(HL)                   ;;
    ld (linea_a_buscar+1),a     ;; cambia la línea a explorar
    XOR A                       ;;
    call detecta_teclado_x      ;; esta rutina lee la línea del teclado correspondiente
    DEC hl                      ;; pero sólo nos interesa una de las teclas.
    and (HL)                    ;; para filtrar por el bit de la tecla (puede haber varias pulsadas)
    CP (hl)                     ;; comprueba si el byte coincide
    db #CC                      ;; jp z
    funcion_tecla: db 0,0       ;; Llama a la función de control invertido
    ret

detecta_teclado_x:              ;Tomado de las rutinas básicas que aparecen en los documentos de Kevin Thacker
    ld bc,&f7*256+%10000010
    out (c),c                   ;PPI A OUT. RESET.

    ld bc,&f400+14              ;Registro 14 del PSG (Puerta A)
    out (c),c                   ;(contains keyboard line data)

    ld b,&f6                    ;PSG control
    ld c,%11000000              ;Select Register 14 for use
    out (c),C                   ;send

    ld c,0                      ;PSG inactive
    out (c),c                   ;send

    ld b,&f7                    ;8255 PPI control
    ld c,%10010010              ;Port A and Port C (upper) - Operating mode 0
                                ;Port A input, Port C (upper) output.

                                ;Port B and Port C (lower) - Operating mode 0
                                ;Port B input, Port C (lower) output

    out (c),c                   ;send control byte

    ld b,&F6                    ;PSG control + keyboard line wanted
    ld a,%01000000              ;PSG control - read

linea_a_buscar:
    or 1                        ;keyboard line 1 ;Cambio esta línea para explorar distintas líneas del teclado.
    out (c),a                   ;send it
    ld b,&F4                    ;Port to get PSG port A (register 14) data
    in a,(c)                    ;Keyboard data from keyboard line 9
    cpl
    ret

esc_pulsado:
    ld a,(teclado)
    or %00010001
    ld (teclado),a
    ret

tecla_izquierda_pulsada:
    ld a,(teclado)
    or %00000001
    ld (teclado),a
    ret

tecla_derecha_pulsada:
    ld a,(teclado)
    or %00000010
    ld (teclado),a
    ret

tecla_arriba_pulsada:
    ld a,(teclado)
    or %00000100
    ld (teclado),a
    ret

tecla_abajo_pulsada:
    ld a,(teclado)
    or %00001000
    ld (teclado),a
    ret

tecla_s_pulsada:
    ld a,(teclado)
    or %00100000
    ld (teclado),a
    ret