org #0040

run Before

read "C:\WinAPE\NitaGame\NitaGame-1\Libs\CRTCLib.asm"
read "C:\WinAPE\NitaGame\NitaGame-1\Libs\Macros.asm"
read "C:\WinAPE\NitaGame\NitaGame-1\Libs\Lib_Config.asm"
read "C:\WinAPE\NitaGame\NitaGame-1\Libs\Lib_System.asm"
read "C:\WinAPE\NitaGame\NitaGame-1\Libs\Lib_Graphics.asm"
read "C:\WinAPE\NitaGame\NitaGame-1\Libs\Lib_DobleBuffer.asm"
read "C:\WinAPE\NitaGame\NitaGame-1\Libs\Lib_Compress.asm"
read "C:\WinAPE\NitaGame\NitaGame-1\Libs\Lib_Puntuacion.asm"
read "C:\WinAPE\NitaGame\NitaGame-1\CuadroJuego\CuadroJuego.asm"
read "C:\WinAPE\NitaGame\NitaGame-1\Graficos\graphics.asm"
read "C:\WinAPE\NitaGame\NitaGame-1\Screens\screens.asm"
read "C:\WinAPE\NitaGame\NitaGame-1\Screens\surfaces.asm"
read "C:\WinAPE\NitaGame\NitaGame-1\Screens\walls.asm"
read "C:\WinAPE\NitaGame\NitaGame-1\Screens\murals.asm"
read "C:\WinAPE\NitaGame\NitaGame-1\Entities\Entities.asm"
read "C:\WinAPE\NitaGame\NitaGame-1\Textos\Textos.asm"
read "C:\WinAPE\NitaGame\NitaGame-1\Animations\Animations.asm"

reseteo:				db RESET_ON
tiempo_menu:			db 20
puntuacion: 			dw 0

Before:
	set_Screen_Height 0

	setStartStack STACK			;;Cambiamos la ubicación de la pila
	startVSync					;;Iniciamos vSync para que coincida con el inicio del raster
	call start_Config			;;Establece los colores y borra la pantalla
	call DB_mem_Start			;;Inicializa el doble buffer
	delay 3
	disableFirmware				;;Deshabilita el firmware
	renderPanel CUADRO_C000
	renderPanel CUADRO_8000
	set activeScreen, START_SCREEN
	call make_screen
	call initial

Inicio:
	cleanScreenArea CUADRO_C000, 4, 38, 2, 19, INK1
	cleanScreenArea CUADRO_8000, 4, 38, 2, 19, INK1
	
	printString 16, 9, txt_EncuentraPartes
	ld a, (reseteo)
	cp RESET_OFF
	call nc, DB_execute
	setReseteo RESET_ON

	delay 127
	delay 127

	call renderSelectedScreen
	renderSpryteSimple 1, 19, nitaGrande
	renderSpryteSimple 11, 21, nitaTitulo
	printNumber 38, 20, valNumericos
	call render_Lives

	call DB_execute
	call renderSelectedScreen
	renderSpryteSimple 1, 19, nitaGrande
	renderSpryteSimple 11, 21, nitaTitulo
	printNumber 38, 20, valNumericos
	call render_Lives

	call DB_execute
	call bucle_juego
	jr $

bucle_juego:
	delay 3
	call restoreSelectedScreen
	call objetos_back
	call Humo
	call momento_juego
	call objetos_front
	ld de, renderiza_movimiento
	ld (function_loop), de
	call render_entities
	call DB_execute
	jr bucle_juego

momento_juego:
	condition Equals, Nita_muerte, COLLISION, fuera_juego
	condition Equals, Nita_muerte, NOT_COLLISION, mover_heroe
	ret

reinicia:
	set temblado, 0
	set num_huevos, 12
	call cierraPuertas
	renderPanel CUADRO_C000
	renderPanel CUADRO_8000
	setReseteo RESET_OFF
	set descontar, 1
	set tiempo_vuelta, 10
	set activeScreen, START_SCREEN
	set Nita_pos_Y, 13
	set Nita_pos_X, 2
	call setNita_vive
	setInitScreen START_OBJECTS
	call make_screen
	call initialize_objects
	set puntuacion, 0
	ld hl, valNumericos
	ld c, 5
	resetea_contador;
	ld (hl), a
	inc hl
	dec c
	jp nz, resetea_contador
	call Inicio

newLive:
	set temblado, 0
	setReseteo RESET_OFF
	set descontar, 1
	set tiempo_vuelta, 10
	call setNita_vive
	setInitScreen START_OBJECTS
	set parpadeo, NITA_PARPADEA		;; Parpadeo e inmunidad temporal
	call Inicio

tiempo_vuelta: db 10
descontar: db 1

fuera_juego:
	call decrease_Lives

	call update_pos_X_Anterior
	call update_pos_Y_Anterior

	condition EqualsCall, Nita_muerte, COLLISION, Nita_pierde

	ld a, (descontar)
	dec a
	call z, decNitaVidas
	ld a, 2
	ld (descontar), a
	condition Zero, Nita_vidas, NO_LIVES, volver_menu
	ld a, (tiempo_vuelta)
	dec a
	ld (tiempo_vuelta), a
	jp z, newLive

	ret

volver_menu:
	decreases tiempo_menu
	;;Esto irá al menú de Inicio para volver a empezar
	condition Zero, tiempo_menu, 0, menu_principal
	ret

menu_principal:
	call fadeOut
	initial:
	set tiempo_menu, 20
	renderPanel CUADRO_8000
	call DB_execute
	renderPanel CUADRO_C000

	cleanScreenArea CUADRO_C000, 4, 38, 2, 8, INK2
	cleanScreenArea CUADRO_8000, 4, 38, 2, 8, INK2
	cleanScreenArea CUADRO_C000, 4, 38, 8, 9, INK3
	cleanScreenArea CUADRO_8000, 4, 38, 8, 9, INK3

	menu_principal_bucle:
	printString 3, 16, txt_Hathus
	
	printString 21, 9, txt_startGame
	printString 6, 12, txt_teclasJuego
	printString 25, 13, txt_cursors
	printNumber 59, 16, num_Any

	renderSpryteSimple 23, 3, nita_sombra
	renderSpryteSimple 24, 2, nitaGrande
	renderSpryteSimple 34, 4, nitaTitulo
	call DB_execute
	renderSpryteSimple 23, 3, nita_sombra
	renderSpryteSimple 24, 2, nitaGrande
	renderSpryteSimple 34, 4, nitaTitulo

	call fadeIn

	menu_principal_bucle2:
	call detecta_teclas_hardware
	ld a, (teclado)

	cp %00100000
	jp z, resetea					;;reset
	jp menu_principal_bucle2

fadeOut:
	ld de, 25
	height_out:
	delay 12
	call CRTC_V_auto
	dec e
	jp nz, height_out
	call CRTC_V_auto
	ret

fadeIn:
	ld de, 0
	height_in:
	delay 12
	call CRTC_V_auto
	inc e
	ld a, e
	cp 26
	jp nz, height_in
	ret

temblor:
	ld de, 47
	call CRTC_H_auto
	ld de, 45
	delay 9
	call CRTC_H_auto
	ld de, 46
	delay 9
	call CRTC_H_auto
	ret

FIN_PROGRAMA: