let muralParams 	= 6		;; Número de parámetros del array de murals

let s_line_end  = 2         ;; Linea de la pantalla
let s_end    	= 3         ;; Posición de inicio
let s_mural_tyle= 4			;; tyle a dibujar
let s_mural_type= 5			;; tyle a dibujar

backgrounds: db 0,0
murals: db 0,0

render_background:
	ld hl, (backgrounds)
	ld (renderizable), hl
	call render_all_murals
	ret

render_murals:
	ld hl, (murals)
	ld (renderizable), hl
	call render_all_murals
	ret

render_all_murals:
	;;ld ix, murals1
	db #DD,#21
	renderizable: db 0,0
	condition ZeroRet, ix + s_line, END_ELEMENTS, null
	ld c, muralParams
	loop_rend_mural_1:
		dec ix
		dec c
		jp nz, loop_rend_mural_1
	loop_render_mural:
	ld c, muralParams
	loop_rend_mural_2:
		inc ix
		dec c
		jp nz, loop_rend_mural_2

		condition ZeroRet, ix + s_line, END_ELEMENTS, null
		condition ZeroCall, ix + s_mural_type, 4, crea_duplo
		condition ZeroCall, ix + s_mural_type, 3, crea_escalera
		condition ZeroCall, ix + s_mural_type, 2, crea_escalera
		condition ZeroCall, ix + s_mural_type, 1, crea_objeto
		condition ZeroCall, ix + s_mural_type, 0, crea_mural

		jp loop_render_mural
	ret

crea_mural:
	ld a, (ix + s_start)
	ld b, a
	call linea
	ld a, (ix + s_line_end)
	loop_ini_col_mural:
		inc hl
		dec b
		jp nz, loop_ini_col_mural
		loop_pinta_col_mural:
			push af
			ld a, (ix + s_mural_tyle)
			ld (hl), a
			set no_pintar_muro, 0
			set pinta_tyle, 0
			pop af
			call avanza_columna_mural
			dec a
			jp nz, loop_pinta_col_mural
	ret

crea_objeto:
	ld a, (ix + s_start)
	ld b, a
	call linea
	ld a, (ix + s_line_end)
	loop_ini_col_objeto:
		inc hl
		dec b
		jp nz, loop_ini_col_objeto
			ld a, (ix + s_mural_tyle)
			ld (hl), a
			inc a
			inc hl
			ld (hl), a
			dec hl
			call avanza_columna
			ld a, (ix + s_mural_tyle)
			inc a
			inc a
			ld (hl), a
			inc a
			inc hl
			ld (hl), a
	ret

crea_duplo:
	ld a, (ix + s_start)
	ld b, a
	call linea
	ld a, (ix + s_line_end)
	loop_ini_col_duplo:
		inc hl
		dec b
		jp nz, loop_ini_col_duplo
		ld a, (ix + s_mural_tyle)
		ld (hl), a
		inc a
		inc hl
		ld (hl), a
	ret

crea_escalera:
	ld a, (ix + s_start)
	ld b, a
	call linea
	ld a, (ix + s_line_end)
	loop_ini_col_escalera:
		inc hl
		dec b
		jp nz, loop_ini_col_escalera
		ld a, 8
		ld b, a
		loop_pinta_col_escalera:
			ld a, b
			cp 1
			jp z, pinta_tyle_paso_der
			ld a, (ix + s_mural_tyle)
			ld (hl), a
			inc a
			inc hl
			ld (hl), a
			condition ZeroCall, ix + s_mural_type, 3, decrementa_columna
			call avanza_columna
			dec b
			jp nz, loop_pinta_col_escalera
	ret

pinta_tyle_paso_der:
	condition Zero, ix + s_mural_type, 3, pinta_tyle_paso_izq
	ld a, TYLE_PASO1
	ld (hl), a
	inc a
	inc hl
	ld (hl), a
	ret

pinta_tyle_paso_izq:
	ld a, TYLE_PASO3
	ld (hl), a
	inc a
	inc hl
	ld (hl), a
	ret

decrementa_columna:
	dec hl
	dec hl
	ret

no_pintar_muro: db 1
pinta_tyle: db 0

avanza_columna_mural:
	ld c, 34
	siguiente_posicion_mural:
	inc hl
	push af
	ld a, (ix + s_end)
	ld b, a
	increases pinta_tyle
	cp b
	call z, marca_no_pintar
	get no_pintar_muro
	cp 1
	jp z, continua_sin_pintar
	ld a, (ix + s_mural_tyle)
	ld (hl), a
	continua_sin_pintar:
	pop af
	dec c
	jp nz, siguiente_posicion_mural
	ret

marca_no_pintar:
	set no_pintar_muro, 1
	ret