let surfaceParams 	= 4		;; Número de parámetros del array de surfaces

let s_line	    = 0         ;; Linea de la pantalla
let s_start    	= 1         ;; Posición de inicio
let s_long      = 2			;; Longitud
let s_tyle		= 3			;; tyle a dibujar

render_surfaces:
	;;ld ix, surfaces1
	db #DD,#21
	surfaces: db 0,0
	condition ZeroRet, ix + s_line, END_ELEMENTS, null
	ld c, surfaceParams
	loop_rend_surface_1:
		dec ix
		dec c
		jp nz, loop_rend_surface_1
	loop_render_surface:
	ld c, surfaceParams
	loop_rend_surface_2:
		inc ix
		dec c
		jp nz, loop_rend_surface_2
		
		condition ZeroRet, ix + s_line, END_ELEMENTS, null

		call crea_superficie

		jp loop_render_surface
	ret

crea_superficie:
	ld a, (ix + s_start)
	ld b, a
	call linea
	ld a, (ix + s_long)
	loop_ini_col:
		inc hl
		dec b
		jp nz, loop_ini_col
		loop_pinta_col:
			push af
			ld a, (ix + s_tyle)
			ld (hl), a
			pop af
			inc hl
			dec a
			jp nz, loop_pinta_col
	ret

linea:
	push bc
	ld a, 34
	ld b, a
	ld hl, BG_Ciudad
	dec hl
	ld a, (ix + s_line)
	ld c, a
	dec c
	jp z, end_loop_line
	loop_line:
		inc hl
		dec b
		jp nz, loop_line
		ld a, 34
		ld b, a
		dec c
		jp nz, loop_line
	end_loop_line:
	pop bc
	ret 

restaura_fondo:
	push bc
	push hl
	push de
	ld a, 34
	ld b, a
	ld a, 17
	ld c, a
	ld hl, BG_Ciudad
	ld de, bak_BG_Ciudad
	loop_rest_col:
		ld a, (de)
		ld (hl), a
		inc de
		inc hl
		dec b
		jp nz, loop_rest_col
		ld a, 34
		ld b, a
		dec c
		jp nz, loop_rest_col
	pop de
	pop hl
	pop bc
	ret

comprueba_superficie:
	ld a, 34
	ld b, a
	ld hl, BG_Ciudad
	dec hl
	get Nita_pos_Y
	inc a
	ld c, a
	loop_line_surface:
		inc hl
		dec b
		jp nz, loop_line_surface
		ld a, 34
		ld b, a
		dec c
		jp nz, loop_line_surface
		get Nita_pos_X
		dec a
		inc hl
		loop_column:
			inc hl	
			dec a
			jp z, loop_column_evalue
			dec a
			jp nz, loop_column
			loop_column_evalue:
			ld a, (hl)
			cp #01
			jp z, detectada_superficie
			cp #02
			jp z, detectada_superficie
			cp #03
			jp z, detectada_superficie
			cp TYLE_LADRILLOS
			jp z, detectada_superficie
			cp TYLE_ESCALERA1
			jp z, detectada_superficie
			cp TYLE_ESCALERA2
			jp z, detectada_superficie
			cp TYLE_ESCALERA3
			jp z, detectada_superficie
			cp TYLE_ESCALERA4
			jp z, detectada_superficie
			cp TYLE_PASO1
			jp z, detectada_superficie
			cp TYLE_PASO2
			jp z, detectada_superficie
			cp TYLE_PASO3
			jp z, detectada_superficie
			cp TYLE_PASO4
			jp z, detectada_superficie
			cp TYLE_SUELO
			jp z, detectada_superficie
			cp TYLE_CAJA1
			jp z, detectada_superficie
			cp TYLE_CAJA2
			jp z, detectada_superficie
			cp TYLE_CAJACARTON1
			jp z, detectada_superficie
			cp TYLE_CAJACARTON2
			jp z, detectada_superficie
			cp TYLE_BIGA
			jp z, detectada_superficie
			cp TYLE_PUERTA
			jp z, detectada_superficie
			cp TYLE_MESA
			jp z, detectada_superficie
			cp TYLE_MESA2
			jp z, detectada_superficie
			condition Zero, Nita_pos_Y, 16, pantalla_abajo
	ret 

techo: db 0

comprueba_techo:
	set techo, 0
	ld a, 34
	ld b, a
	ld hl, BG_Ciudad
	dec hl
	get Nita_pos_Y
	dec a
	dec a
	ld c, a
	loop_line_top:
		inc hl
		dec b
		jp nz, loop_line_top
		ld a, 34
		ld b, a
		dec c
		jp nz, loop_line_top
		get Nita_pos_X
		dec a
		inc hl
		loop_column_top:
			inc hl	
			dec a
			jp z, loop_column_evalue_top
			dec a
			jp nz, loop_column_top
			loop_column_evalue_top:
			ld a, (hl)
			cp TYLE_LADRILLOS
			jp z, detectado_techo
			cp TYLE_SUELO
			jp z, detectado_techo
			cp TYLE_CAJA3
			jp z, detectado_techo
			cp TYLE_CAJA4
			jp z, detectado_techo
			cp TYLE_CAJACARTON3
			jp z, detectado_techo
			cp TYLE_CAJACARTON4
			jp z, detectado_techo
			condition ZeroCall, Nita_pos_Y, 1, pantalla_arriba	;; Comprobamos si se ha alcanzado el limite de pantalla
	ret 

detectada_superficie:
	get Nita_pos_Y
	ld b, a
	sub a, b
	ret

detectado_techo:
	set techo, 1
	ret

sin_suelo:
	ld a, 1
	ld b, a
	call linea_suelo
	ld a, 34
	loop_sin_suelo:
		inc hl
		dec b
		jp nz, loop_sin_suelo
		loop_borra_suelo:
			ld (hl), #00
			inc hl
			dec a
			jp nz, loop_borra_suelo
	ret

linea_suelo:
	push bc
	ld a, 34
	ld b, a
	ld hl, BG_Ciudad
	dec hl
	ld a, 17
	ld c, a
	dec c
	jp z, end_loop_line_suelo
	loop_line_suelo:
		inc hl
		dec b
		jp nz, loop_line
		ld a, 34
		ld b, a
		dec c
		jp nz, loop_line_suelo
	end_loop_line_suelo:
	pop bc
	ret 